﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Transactions;
using System.Data.SqlClient;

namespace ohjaus5
{
    public partial class Form1 : Form
    {
        public ohjaus5Entities Ctx;
        private DataTable l;
        public Form1()
        {
            InitializeComponent();
            Ctx = new ohjaus5Entities();
        }

        private void reseptiBindingNavigatorSaveItem_Click(object sender, EventArgs e)
        {
            this.Validate();
            this.reseptiBindingSource.EndEdit();
            this.tableAdapterManager.UpdateAll(this.ohjaus5DataSet);

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'ohjaus5DataSet.Liittyy_liitos' table. You can move, or remove it, as needed.
            this.liittyy_liitosTableAdapter.Fill(this.ohjaus5DataSet.Liittyy_liitos);
            // TODO: This line of code loads data into the 'ohjaus5DataSet.Ruokalaji' table. You can move, or remove it, as needed.
            this.ruokalajiTableAdapter.Fill(this.ohjaus5DataSet.Ruokalaji);
            // TODO: This line of code loads data into the 'ohjaus5DataSet.Liittyy' table. You can move, or remove it, as needed.
            this.liittyyTableAdapter.Fill(ohjaus5DataSet.Liittyy);
            // TODO: This line of code loads data into the 'ohjaus5DataSet.Ohje' table. You can move, or remove it, as needed.
            this.ohjeTableAdapter.Fill(this.ohjaus5DataSet.Ohje);
            // TODO: This line of code loads data into the 'ohjaus5DataSet.Resepti' table. You can move, or remove it, as needed.
            this.reseptiTableAdapter.Fill(this.ohjaus5DataSet.Resepti);
            //            reseptiBindingSource.RemoveCurrent();
            /*            ohjeBindingSource.RemoveCurrent();
                        this.tableAdapterManager.UpdateAll(this.ohjaus5DataSet);
                        var juttu = from a in Ctx.Aine
                                    from r in Ctx.Resepti
                                    where r.Liittyy == a.Liittyy
                                    select r.Nimi;
                        listBox1.DataSource = juttu;*/

            l = this.liittyyTableAdapter.GetDataBy();
            liittyyBindingSource.DataSource = l;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.IO.StringWriter writer = new System.IO.StringWriter();

            try
            {
                // Create the TransactionScope to execute the commands, guaranteeing
                // that both commands can commit or roll back as a single unit of work.
                using (TransactionScope scope = new TransactionScope())
                {

                    for (int i = liittyyBindingSource.Count - 1; i >= 0; i--)
                    {
                        liittyyBindingSource.RemoveAt(i);
                    }
                    for (int i = ohjeBindingSource.Count - 1; i >= 0; i--)
                    {
                        ohjeBindingSource.RemoveAt(i);
                    }

                    ohjeBindingSource.EndEdit(); // lienee tarpeeton?
                    ohjaus5DataSet.OhjeDataTable deletedOhjeRecords = (ohjaus5DataSet.OhjeDataTable)ohjaus5DataSet.Ohje.GetChanges(DataRowState.Deleted);
                    if (deletedOhjeRecords != null) ohjeTableAdapter.Update(deletedOhjeRecords);

                    liittyyBindingSource.EndEdit(); // lienee tarpeeton?
                    ohjaus5DataSet.LiittyyDataTable deletedLiittyyRecords = (ohjaus5DataSet.LiittyyDataTable)ohjaus5DataSet.Liittyy.GetChanges(DataRowState.Deleted);
                    if (deletedLiittyyRecords != null) liittyyTableAdapter.Update(deletedLiittyyRecords);

                    reseptiBindingSource.EndEdit(); // lienee tarpeeton?
                    reseptiBindingSource.RemoveCurrent();
                    ohjaus5DataSet.ReseptiDataTable deletedReseptiRecords = (ohjaus5DataSet.ReseptiDataTable)ohjaus5DataSet.Resepti.GetChanges(DataRowState.Deleted);
                    if (deletedReseptiRecords != null) reseptiTableAdapter.Update(deletedReseptiRecords);
                    scope.Complete();


                }

            }
            catch (SqlException ex)
            {
                writer.WriteLine("sqlexception error: {0}", ex.Message);
            }
            catch (DBConcurrencyException ex)
            {
                writer.WriteLine("Concurrency error: {0}", ex.Message);
            }
            catch (TransactionAbortedException ex)
            {
                writer.WriteLine("TransactionAbortedException Message: {0}", ex.Message);
            }
            catch (ApplicationException ex)
            {
                writer.WriteLine("ApplicationException Message: {0}", ex.Message);
            }

            this.Text = writer.ToString();
            this.liittyyTableAdapter.Fill(this.ohjaus5DataSet.Liittyy);
            // TODO: This line of code loads data into the 'ohjaus5DataSet.Ohje' table. You can move, or remove it, as needed.
            this.ohjeTableAdapter.Fill(this.ohjaus5DataSet.Ohje);
            // TODO: This line of code loads data into the 'ohjaus5DataSet.Resepti' table. You can move, or remove it, as needed.
            this.reseptiTableAdapter.Fill(this.ohjaus5DataSet.Resepti);


       }

        private void button2_Click(object sender, EventArgs e)
        {
            // päivitä tietoja
            try
            {
                using (TransactionScope scope = new TransactionScope())
                {

                    DataRowView v = (DataRowView)liittyyBindingSource.Current;
                    DataRow l = v.Row;
                    l.SetField("Maara", 10);

                    liittyyBindingSource.EndEdit(); // lienee tarpeeton?
                    ohjaus5DataSet.LiittyyDataTable updatedLiittyyRecords = (ohjaus5DataSet.LiittyyDataTable)ohjaus5DataSet.Liittyy.GetChanges(DataRowState.Modified);
                    if (updatedLiittyyRecords != null) liittyyTableAdapter.Update(updatedLiittyyRecords);

                    reseptiBindingSource.EndEdit(); // lienee tarpeeton?

                    DataRowView v2 = (DataRowView)reseptiBindingSource.Current;
                    DataRow r = v2.Row;
                    r.SetField("Nimi", "Uusi nimi");
                    ohjaus5DataSet.ReseptiDataTable updatedReseptiRecords = (ohjaus5DataSet.ReseptiDataTable)ohjaus5DataSet.Resepti.GetChanges(DataRowState.Modified);
                    if (updatedReseptiRecords != null) reseptiTableAdapter.Update(updatedReseptiRecords);

                    scope.Complete();

                }

            }
            catch (ApplicationException ex)
            {
            }

            this.liittyyTableAdapter.Fill(this.ohjaus5DataSet.Liittyy);
            // TODO: This line of code loads data into the 'ohjaus5DataSet.Ohje' table. You can move, or remove it, as needed.
            this.ohjeTableAdapter.Fill(this.ohjaus5DataSet.Ohje);
            // TODO: This line of code loads data into the 'ohjaus5DataSet.Resepti' table. You can move, or remove it, as needed.
            this.reseptiTableAdapter.Fill(this.ohjaus5DataSet.Resepti);

        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                using (TransactionScope scope = new TransactionScope())
                {
                    // lisää tietoja
                    DataRow resepti = this.ohjaus5DataSet.Resepti.NewReseptiRow();
                    resepti.SetField("Nimi", "Testisoppa");
                    resepti.SetField("RuokaLajiID", 1);
                    resepti.SetField("Kuvaus", "kansallisherkku");
                    resepti.SetField("Henkilomaara", 1);
                    this.ohjaus5DataSet.Resepti.Rows.Add(resepti);
                    ohjaus5DataSet.ReseptiDataTable insertedReseptiRecords = (ohjaus5DataSet.ReseptiDataTable)ohjaus5DataSet.Resepti.GetChanges(DataRowState.Added);

                    if (insertedReseptiRecords != null) reseptiTableAdapter.Update(insertedReseptiRecords);
                    // pakko kutsua UpdateAll
                    this.tableAdapterManager.UpdateAll(this.ohjaus5DataSet);
                    // on oikea arvo vasta edellisen UpdateAll-kutsun jälkeen!
                    int reseptiID = (int)resepti["ReseptiID"];
                    // nyt voidaan lisätä ohjerivejä
//                    DataRow o = this.ohjaus5DataSet.Ohje.NewOhjeRow();
                    ohjaus5DataSet.OhjeRow o = this.ohjaus5DataSet.Ohje.NewOhjeRow();
//                    ohje.SetField("ReseptiID", reseptiID);
                    o.SetField("ReseptiID", reseptiID);
                    o.SetField("Vaihenro", 10);
                    o.SetField("Ohjeteksti", "Lämmitä kattilassa");
//                    (ohjaus5DataSet.OhjeRow)o.
                   
                    o.ReseptiRow = (ohjaus5DataSet.ReseptiRow)resepti;
                    this.ohjaus5DataSet.Ohje.Rows.Add(o);
                    ohjaus5DataSet.OhjeDataTable insertedOhjeRecords = (ohjaus5DataSet.OhjeDataTable)ohjaus5DataSet.Ohje.GetChanges(DataRowState.Added);
                    if (insertedOhjeRecords != null) ohjeTableAdapter.Update(insertedOhjeRecords);
//  seuraava testikään ei toimi vaan aina yritetään syöttää ohje uudelleen. ei siis pidä kutsua UpdateAll-metodia
// mistä selviäisi milloin UpdateAll pitää ja milloin ei pidä kutsua?
//                    if (ohjaus5DataSet.HasChanges()  )
//                                           this.tableAdapterManager.UpdateAll(this.ohjaus5DataSet);
                    scope.Complete();

                }
            }
            catch (SqlException ex)
            {
                this.Text = ex.Message;
            }
            catch (DBConcurrencyException ex)
            {
                this.Text = ex.Message;
            }
            catch (TransactionAbortedException ex)
            {
                this.Text = ex.Message;
            }
            catch (SystemException ex)
            {
                this.Text = ex.Message;
            }
            catch (ApplicationException ex)
            {
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {

            // ei toimi tässä vaan antaa omituisen poikkeuksen
            try
            {
                using (TransactionScope scope = new TransactionScope())
                {
                    Resepti r = new Resepti();
                    r.Nimi = "Mustikkakiisseli";
                    r.Henkilomaara = 1;
                    r.Kuvaus = "Aamusafka";
                    r.RuokalajiID = 1;

                    Ctx.Resepti.AddObject(r);
                    Ctx.SaveChanges();

                    scope.Complete();

                }
            }
            catch (SqlException ex)
            {
                this.Text = ex.Message;
            }
            catch (DBConcurrencyException ex)
            {
                this.Text = ex.Message;
            }
            catch (TransactionAbortedException ex)
            {
                this.Text = ex.Message;
            }
            catch (SystemException ex)
            {
                this.Text = ex.Message;
            }
            catch (ApplicationException ex)
            {
            }



        }

        private void button5_Click(object sender, EventArgs e)
        {

            try
            {
                using (TransactionScope scope = new TransactionScope())
                {
                    // lisää tietoja
                    ohjaus5DataSet.RuokalajiRow r = this.ohjaus5DataSet.Ruokalaji.NewRuokalajiRow();
                    r.SetField("Nimi", "Hernesoppa");
                    r.SetField("Kuvaus", "kansallisherkku");
                    this.ohjaus5DataSet.Ruokalaji.Rows.Add(r);
                    ohjaus5DataSet.RuokalajiDataTable insertedReseptiRecords = (ohjaus5DataSet.RuokalajiDataTable)ohjaus5DataSet.Ruokalaji.GetChanges(DataRowState.Added);
                   
                    if (insertedReseptiRecords != null) ruokalajiTableAdapter.Update(insertedReseptiRecords);
                    this.tableAdapterManager.UpdateAll(this.ohjaus5DataSet);
                    int ruokalajiID = (int)r["RuokalajiID"];

                    DataRow resepti = this.ohjaus5DataSet.Resepti.NewReseptiRow();
                    resepti.SetField("Nimi", "Hernesoppa");
                    resepti.SetField("RuokaLajiID", 1);
                    resepti.SetField("Kuvaus", "kansallisherkku");
                    resepti.SetField("Henkilomaara", 1);
                    this.ohjaus5DataSet.Resepti.Rows.Add(resepti);
                    ohjaus5DataSet.ReseptiDataTable insertedRRecords = (ohjaus5DataSet.ReseptiDataTable)ohjaus5DataSet.Resepti.GetChanges(DataRowState.Added);

                    if (insertedRRecords != null) reseptiTableAdapter.Update(insertedRRecords);
                    // täällä updateall ei sotke tilannetta
                    this.tableAdapterManager.UpdateAll(this.ohjaus5DataSet);
                    
                    scope.Complete();

                }
            }
            catch (SqlException ex)
            {
                this.Text = ex.Message;
            }
            catch (DBConcurrencyException ex)
            {
                this.Text = ex.Message;
            }
            catch (TransactionAbortedException ex)
            {
                this.Text = ex.Message;
            }
            catch (SystemException ex)
            {
                this.Text = ex.Message;
            }
            catch (ApplicationException ex)
            {
            }

        }
    }
}
